Bug 960553 - 508-L Toolbar menu item scripts do not work with the keyboard
Summary: 508-L Toolbar menu item scripts do not work with the keyboard
Keywords:
Status: CLOSED CURRENTRELEASE
Alias: None
Product: JBoss Enterprise Portal Platform 6
Classification: JBoss
Component: Portal
Version: 6.0.0
Hardware: Unspecified
OS: Unspecified
high
unspecified
Target Milestone: ---
: 6.1.0
Assignee: Lucas Ponce
QA Contact: Dominik Pospisil
URL:
Whiteboard:
Depends On:
Blocks: 960060
TreeView+ depends on / blocked
 
Reported: 2013-05-07 11:35 UTC by Dominik Pospisil
Modified: 2015-04-20 11:21 UTC (History)
2 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2013-11-07 14:22:02 UTC
Type: Bug


Attachments (Terms of Use)
toolbar scripts (21.00 KB, application/octet-stream)
2013-05-07 11:36 UTC, Dominik Pospisil
no flags Details


Links
System ID Priority Status Summary Last Updated
Red Hat Issue Tracker GTNPORTAL-3027 Major Resolved Toolbar menu item scripts do not work with the keyboard 2015-04-20 11:20:19 UTC

Description Dominik Pospisil 2013-05-07 11:35:54 UTC
508-L Toolbar menu item scripts do not work with the keyboard fuctions. Only way user has access to these function is by use of the mouse. Scripts should be made directly accessible whenever possible by employing natively keyboard-accessible markup elements (such as anchors and forms) and generic event handlers (such as onfocus, onblur and onselect).

This violates 508 certification requirements: ยง 1194.22 (l) Scripts
When pages utilize scripting languages to display content, or to create interface elements, the information provided by the script shall be identified with functional text that can be read by assistive technology.

Comment 1 Dominik Pospisil 2013-05-07 11:36:25 UTC
Created attachment 744690 [details]
toolbar scripts

Comment 2 Lucas Ponce 2013-05-14 09:17:55 UTC
After having studied this issue we can summary status as follow:

- Menu navigation components are deal with jQuery in the module UIPortalNavigation.js.

- Current design doesn't allow to use keyboard to navigate into the menu elements, some top menu elements are not <a> tags, and also there is not an event to show the children when <a> link is active.

- A change can be possible using a different approach, some examples can be shown in these discussions:

http://stackoverflow.com/questions/14510846/jquery-is-it-possible-to-bind-css-hover-focus-behaviours-to-keydown

and this online-demo:

http://jsfiddle.net/greenrobo/eLCmM/

In these examples, when a link is active, the children can be showed, as expected.

- Introduce this change can affect whole UIPortalNavigation.js, refactor the current design to introduce key events.

So, I would check with Thomas Heute how to proceed with this one.

Comment 3 Lucas Ponce 2013-05-15 14:15:07 UTC
Update:

- wrapping some menu elements with <a> tags instead of <span>.
- Adding focusin/focusout jquery handlers with similar behaviour of mouseenter/mouseleave.

With these small changes, now, menu tool bar and submenus are accessible with keyboard without any major change in the current JavaScript design.


Note You need to log in before you can comment on or make changes to this bug.